Package: synapsis
Type: Package
Title: An R package to automate the analysis of double-strand break
        repair during meiosis
Version: 1.18.0
Authors@R: 
    c(person(given = "Lucy",
             family = "McNeill",
             role = c("aut", "cre", "cph"),
             email = "luc.mcneill@gmail.com",
             comment = c(ORCID = "0000-0003-1752-4882")),
      person(given = "Wayne",
             family = "Crismani",
             role = c("rev", "ctb"),
             comment = c(ORCID = "0000-0003-0143-8293")))
Description: Synapsis is a Bioconductor software package for automated (unbiased and reproducible) analysis of meiotic immunofluorescence datasets. The primary functions of the software can i) identify cells in meiotic prophase that are labelled by a synaptonemal complex axis or central element protein, ii) isolate individual synaptonemal complexes and measure their physical length, iii) quantify foci and co-localise them with synaptonemal complexes, iv) measure interference between synaptonemal complex-associated foci. The software has applications that extend to multiple species and to the analysis of other proteins that label meiotic prophase chromosomes. The software converts meiotic immunofluorescence images into R data frames that are compatible with machine learning methods. Given a set of microscopy images of meiotic spread slides, synapsis crops images around individual single cells, counts colocalising foci on strands on a per cell basis, and measures the distance between foci on any given strand.
biocViews: Software, SingleCell
Depends: R (>= 4.1)
Imports: EBImage, stats, utils, graphics
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.1.1
VignetteBuilder: knitr
Suggests: knitr, rmarkdown, testthat (>= 3.0.0), ggplot2, tidyverse,
        BiocStyle
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/synapsis
git_branch: RELEASE_3_23
git_last_commit: e5748f3
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:42:21 UTC; biocbuild
Author: Lucy McNeill [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0003-1752-4882>),
  Wayne Crismani [rev, ctb] (ORCID:
    <https://orcid.org/0000-0003-0143-8293>)
Maintainer: Lucy McNeill <luc.mcneill@gmail.com>
Built: R 4.6.0; ; 2026-04-29 05:03:17 UTC; unix

#' count_foci
#'
#' Calculates coincident foci in synaptonemal complex and foci channel, per cell
#'
#' In this function, masks for the synaptonemal complex (SC) and foci channel
#' are created from the saved crops of single/individual cells.
#' These masks are computed using (optional) input parameters related
#' to meiosis stage/ how well spread chromosomes are (for the former)
#' and related to smoothing, thresholding and how "crowded" foci are for the
#' latter. Finally, these two masks are multiplied, and the number of
#' objects found with EBImage's computeFeatures are the colocalizing foci.
#'
#' The file, cell number, foci count etc. are output as a data frame.
#'
#' @export count_foci
#' @param img_path, path containing crops to analyse
#' @param stage, meiosis stage of interest. Currently count_foci determines
#' this with thresholding/ object properties in the synaptonemal complex channel
#' by previosly calling the get_pachytene function.
#' Note that if using this option, the count_foci function requires that the
#' input directory contains a folder called “pachytene” with the crops in it.
#' @param offset_px, Pixel value offset used in thresholding of synaptonemal complex channel
#' @param offset_factor, Pixel value offset used in thresholding of foci channel
#' @param brush_size, size of brush to smooth the foci channel. Should be small
#' to avoid erasing foci.
#' @param brush_sigma, sigma for Gaussian smooth of foci channel. Should be
#' small to avoid erasing foci.
#' @param foci_norm, Mean intensity to normalise all foci channels to.
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param channel1_string String appended to the files showing the channel
#' illuminating foci. Defaults to MLH3
#' @param channel2_string String appended to the files showing the channel
#' illuminating synaptonemal complexes. Defaults to SYCP3
#' @param file_ext file extension of your images e.g. tiff jpeg or png.
#' @param KO_str string in filename corresponding to knockout genotype.
#' Defaults to --.
#' @param WT_str string in filename corresponding to wildtype genotype.
#' Defaults to ++.
#' @param KO_out string in output csv in genotype column, for knockout.
#' Defaults to -/-.
#' @param WT_out string in output csv in genotype column, for knockout.
#' Defaults to +/+.
#' @param watershed_stop Stop default watershed method with "on"
#' @param watershed_radius Radius (ext variable) in watershed method used
#' in foci channel. Defaults to 1 (small)
#' @param watershed_tol Intensity tolerance for watershed method. Defaults to 0.05.
#' @param crowded_foci TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have foci > 100 or so.
#' @param artificial_amp_factor Amplification of foci channel, for annotation only.
#' @param strand_amp multiplication of strand channel to make masks
#' @param min_foci minimum pixel area for a foci. Depends on your dpi etc. Defaults to 4
#' @param disc_size size of disc for local background calculation in synaptonemal complex channel
#' @param modify_problematic option for synapsis to try and "save" images which
#' have likely been counted incorrectly due to a number of reasons. Default
#' settings are optimized for mouse pachytene. Defaults to "off"
#' @param disc_size_foci size of disc for local background calculation in foci channel
#' @param C_weigh_foci_number choose crispness criteria- defaults to TRUE to use
#' C1 (weighing with number). Otherwise set to FALSE to use C2
#' @param C1 Default crispness criteria = sd(foci_area)/(mean(foci_area)+1)
#' @param C2 Alternative crisp criteria.
#' @examples demo_path = paste0(system.file("extdata",package = "synapsis"))
#' foci_counts <- count_foci(demo_path,offset_factor = 3, brush_size = 3,
#' brush_sigma = 3, annotation = "on",stage = "pachytene")
#' @author Lucy McNeill
#' @return data frame with foci count per cell


count_foci <- function(img_path, stage = "none", offset_px = 0.2, offset_factor = 2, brush_size = 3, brush_sigma = 3, foci_norm = 0.01, annotation = "off",channel2_string = "SYCP3", channel1_string = "MLH3",file_ext = "jpeg", KO_str = "--",WT_str = "++",KO_out = "-/-", WT_out = "+/+", watershed_stop = "off", watershed_radius = 1, watershed_tol = 0.05, crowded_foci = TRUE, artificial_amp_factor = 1, strand_amp = 2, min_foci =-1, disc_size = 51, modify_problematic = "off", disc_size_foci = 5, C1 = 0.02, C2 = 0.46, C_weigh_foci_number = TRUE)
{
  cell_count <- 0
  image_count <-0
  antibody1_store <- 0
  antibody2_store <- 0
  if(stage == "pachytene"){
    img_path_new <- paste0(img_path,"/crops/",stage,"/")
  }
  else{
    img_path_new <- paste0(img_path,"/crops/")
  }
  file_list <- list.files(img_path_new)
  df_cols <- c("filename","cell_no","genotype","stage","foci_count", "sd_foci","mean_foci","median_foci","mean_px","median_px", "percent_on","sd_px","lone_foci","comments","verdict","C1")
  df_cells <- data.frame(matrix(ncol = length(df_cols), nrow = 0))
  colnames(df_cells) <- df_cols
  for (img_file in file_list){
    if(stage == "pachytene"){
      filename_path_test <- paste0(img_path,"/crops/",stage,"/", img_file)
    }
    else{
      filename_path_test <- paste0(img_path,"/crops/", img_file)
    }
    img_file <- filename_path_test
    if(grepl(paste0('*',channel2_string,'.',file_ext,'$'), img_file)){
      file_sc <- img_file
      image_count <- image_count +1
      image <- readImage(file_sc)
      img_orig <- channel(strand_amp*image, "grey")
      antibody1_store <- 1
    }
    if(grepl(paste0('*',channel1_string,'.',file_ext,'$'), img_file)){
      file_foci <- img_file
      image <- readImage(file_foci)
      img_orig_foci <- channel(image, "gray")
      antibody2_store <- 1
    }
    if(antibody1_store +antibody2_store == 2){
      C1_search <- TRUE
      antibody1_store <- 0
      antibody2_store <- 0
      discrepant_category <- 0
      cell_count <- cell_count + 1
      df_cells <- get_coincident_foci(offset_px, offset_factor, brush_size,
                                      brush_sigma, annotation,watershed_stop,
                                      watershed_radius, watershed_tol,
                                      crowded_foci, artificial_amp_factor,
                                      strand_amp, disc_size, disc_size_foci,
                                      img_file,cell_count,img_orig,
                                      img_orig_foci, stage,
                                      WT_str,KO_str,WT_out,KO_out, C1_search,
                                      discrepant_category,C1,C2,df_cells, C_weigh_foci_number)
    }
  }
  colnames(df_cells) <- df_cols
  return(df_cells)
}



#' annotate_foci_counting
#'
#' Contains all plotting routines for count foci annotation
#'
#' @param img_file cell's file name
#' @param cell_count unique cell counter
#' @param img_orig original strand crop
#' @param img_orig_foci cropped foci channel
#' @param artificial_amp_factor amplification factor
#' @param strands black white mask of strand channel
#' @param coincident_foci mask of overlap between strand and foci channel
#' @param foci_label black and white mask of foci channel
#' @param percent_px percentage of foci mask that coincides with strand channel
#' small number indicates potentially problematic image.
#' @param alone_foci estimated number of foci that are NOT on a strand.
#' @param foci_per_cell number of foci counted per cell
#' @return displays key steps from raw image to coincident foci count
#'
annotate_foci_counting <- function(img_file,cell_count,img_orig,img_orig_foci,
                                   artificial_amp_factor,strands,
                                   coincident_foci, foci_label,alone_foci,
                                   percent_px,foci_per_cell){
  cat("\n at file",img_file, sep = " ")
  cat("\n cell counter is", cell_count, sep= " ")
  cat("\n original images")
  plot(img_orig)
  plot(img_orig_foci)
  ch1 <-channel(img_orig,"grey")
  ch2 <- channel(artificial_amp_factor*img_orig_foci,"grey")
  bluered <- rgbImage(ch1, ch2, 0*ch1)
  cat("\n displaying resulting foci count plots. Overlay two channels:")
  plot(rgbImage(ch1,ch2,0*img_orig))
  cat("\n displaying resulting masks. Overlay two masks:")
  plot(rgbImage(strands,foci_label,0*img_orig))
  cat("\n coincident foci:")
  plot(colorLabels(coincident_foci))
  cat("\n two channels, only coincident foci")
  plot(rgbImage(strands,coincident_foci,coincident_foci))
  cat("\n which counts this many foci:",foci_per_cell, sep = " ")
  cat("\n number of alone foci",alone_foci, sep = " ")
  if(alone_foci < 0){
    cat("\n this one had a negative lone foci amount. Suspect overcounting of foci in this one:")
    plot(rgbImage(strands,foci_label,0*foci_label))
    #alone_foci <- 0
  }
  tryCatch({
    if(percent_px < 0.3){
      cat("\n file name", img_file, "coincides", percent_px*100,
          "percent. So decided to reduce the local background thresholding
              requirements.", sep = " ")
    }
  },
  error = function(e) {
    #what should be done in case of exception?
    cat("\n percent on was a NaN. Suspect no/low signal")
  }
  )
}

#' append_data_frame
#'
#' applies new row to data frame
#'
#' @param img_file cell's file name
#' @param cell_count unique cell counter
#' @param KO_str string in filename corresponding to knockout genotype.
#' Defaults to --.
#' @param WT_str string in filename corresponding to wildtype genotype.
#' Defaults to ++.
#' @param KO_out string in output csv in genotype column, for knockout.
#' Defaults to -/-.
#' @param WT_out string in output csv in genotype column, for knockout.
#' Defaults to +/+.
#' @param foci_areas pixel area of each foci
#' @param df_cells current data frame
#' @param stage, meiosis stage of interest. Currently count_foci determines
#' this with thresholding/ object properties in the synaptonemal complex channel
#' by previosly calling the get_pachytene function.
#' Note that if using this option, the count_foci function requires that the
#' input directory contains a folder called “pachytene” with the crops in it.
#' @param foci_per_cell foci count for cell
#' @param image_mat matrix with all pixel values above zero
#' @param percent_px percentage of foci mask that coincides with strand channel
#' small number indicates potentially problematic image.
#' @param alone_foci estimated number of foci that are NOT on a strand.
#' @param discrepant_category estimated number of foci that are NOT on a strand.
#' @param C1 criteria
#'
#' @return data frame with new row
#'
append_data_frame <- function(WT_str,KO_str,WT_out,KO_out,img_file,foci_areas,df_cells,cell_count,stage,foci_per_cell,image_mat,percent_px,alone_foci,discrepant_category, C1){
  tryCatch({
    ### data frame stuff
    if(grepl( WT_str, img_file, fixed = TRUE) == TRUE){
      genotype <- WT_out
    }
    if(grepl( KO_str, img_file, fixed = TRUE) == TRUE){
      genotype <- KO_out
    }

    if(foci_per_cell < 2){
      ### force statistics about foci areas to all be zero rather than fail
      foci_areas <- c(0,0)
    }
    ### data frame stuff ends
    if(discrepant_category == 0){
      discrepant_comment <- "meets crisp-ness criteria"
      verdict <- "keep"

    }
    else if(discrepant_category ==1){
      discrepant_comment <- "does not meet crisp-ness criteria"
      verdict <- "discard"
    }
    else if(discrepant_category >1){
      discrepant_comment <- "does not meet crisp-ness criteria"
      verdict <- "discard"
    }

    df_cells <- rbind(df_cells,t(c(img_file,cell_count,genotype,stage,
                                   foci_per_cell, sd(foci_areas),mean(foci_areas),
                                   median(foci_areas),mean(image_mat),median(image_mat),
                                   percent_px,sd(image_mat),alone_foci,discrepant_comment,
                                   verdict,C1)))
  },
  error = function(e) {
    #what should be done in case of exception?
    str(e) # #prints structure of exception
    cat("\n something went wrong while making the data frame")
  }
  )
  return(df_cells)
}


### annotate when the flag has been raised that the percent of foci on is too small.
## Nan case indicates zero, so should move to a separate case of dim foci possibly.
## Change the thresholding to longer be local background (but still smoothed)
## perhaps base the new threshold value on the mean pixel value... rather then difference compared to background?
### then make a test about whether there was an improvement....


#### annonate when a flag has been raised about the XY stuff:
### if sd(foci) is >10* typical value, then you have an XY blob there. Remove it from the mask?

#' remove_XY
#'
#' applies new row to data frame
#'
#' @param foci_label black and white mask of foci channel
#' @param foci_candidates computeFeatures data frame of foci channel
#' @param foci_areas the areas of the foci objects
#'
#'
#'
#' @return mask with XY blob removed
#'
#'
remove_XY <- function(foci_label, foci_candidates, foci_areas){
  ### if the standard deviation was too big
  ### loop over and delete the giant blobs.
  ### after this function is run, coincident foci needs to be computed again.
  median_px <- median(foci_areas)
  #### takes in foci mask. Outputs the new mask without giant blob.
  x <- computeFeatures.shape(foci_label)
  x <- data.frame(x)
  OOI <- nrow(x)
  counter <- 0
  retained <- foci_label
  while(counter<OOI){
    counter <- counter+1
    pixel_area <- x$s.area[counter]
    # if statement checking if it's the big blob
    if(pixel_area> 10*median_px){
      retained <- as.numeric(retained)*rmObjects(foci_label, counter, reenumerate = TRUE)
    }
  }
  return(retained)
  ## multiply with the original foci_label

}

#' make_foci_mask
#'
#' creates foci mask for foci channel crop
#'
#' @param offset_factor Pixel value offset used in thresholding of foci channel
#' @param bg background value- currently just mean pixel value of whole image
#' @param crowded_foci TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have foci > 100 or so.
#' @param img_orig_foci cropped foci channel
#' @param brush_size size of brush to smooth the foci channel. Should be small
#' to avoid erasing foci.
#' @param brush_sigma sigma for Gaussian smooth of foci channel. Should be
#' small to avoid erasing foci.
#' @param disc_size_foci size of disc for local background calculation in foci channel
#' @return foci mask
#'
#'
make_foci_mask <- function(offset_factor,bg,crowded_foci,img_orig_foci,
                           brush_size,brush_sigma,disc_size_foci){
  foci_mask_crop <- img_orig_foci
  offset <- offset_factor*bg
  if(crowded_foci == TRUE){
    ### do local background calculation instead. but still don't smooth.
    #foci_th <- foci_mask_crop > bg + offset
    ### using local bg
    disc_size <- disc_size_foci
    new_img<-foci_mask_crop
    disc <- makeBrush(disc_size, "disc")
    disc <- disc / sum(disc)
    localBackground <- filter2(new_img, disc)
    offset <- 1/(2.8*offset_factor)
    foci_th <- (new_img - localBackground > offset)
  }
  else{
    ### smooth it
    img_tmp_contrast <- foci_mask_crop
    w <- makeBrush(size = brush_size, shape = 'gaussian', sigma = brush_sigma)
    img_flo <- filter2(img_tmp_contrast, w)
    ### using local bg
    disc_size <- disc_size_foci
    new_img<-img_flo
    disc <- makeBrush(disc_size, "disc")
    disc <- disc / sum(disc)
    localBackground <- filter2(new_img, disc)
    offset <- 1/(2.8*offset_factor)
    foci_th <- (new_img - localBackground > offset)

  }
  foci_label <- bwlabel(foci_th)
  return(foci_label)
}

#' make_strand_mask
#'
#' creates strand mask for strand channel crop
#'
#' @param offset_px, Pixel value offset used in thresholding of synaptonemal complex channel
#' @param stage, meiosis stage of interest. Currently count_foci determines
#' this with thresholding/ object properties in the synaptonemal complex channel
#' by previosly calling the get_pachytene function.
#' Note that if using this option, the count_foci function requires that the
#' input directory contains a folder called “pachytene” with the crops in it.
#' @param img_orig original strand crop
#' @param disc_size size of disc for local background calculation in synaptonemal complex channel
#' @param brush_size, size of brush to smooth the foci channel. Should be small
#' to avoid erasing foci.
#' @param brush_sigma, sigma for Gaussian smooth of foci channel. Should be
#' small to avoid erasing foci.
#' @return strand mask
#'
make_strand_mask <- function(offset_px, stage, img_orig, disc_size,brush_size,brush_sigma){
  img_tmp_contrast <- img_orig
  w <- makeBrush(size = brush_size, shape = 'gaussian', sigma = brush_sigma)
  img_flo <- filter2(img_orig, w)
  new_img<-img_flo
  disc <- makeBrush(disc_size, "disc")
  disc <- disc / sum(disc)
  localBackground <- filter2(new_img, disc)
  offset <- offset_px
  if(stage == "pachytene"){
    thresh_crop <- (new_img - localBackground > offset)

  }
  else{
    thresh_crop <- new_img > offset
  }
  strands <- bwlabel(thresh_crop)
  return(strands)
}

#' get_overlap_mask
#'
#' creates mask for coincident foci
#'
#' @param strands black white mask of strand channel
#' @param watershed_stop Stop default watershed method with "on"
#' @param foci_label black and white mask of foci channel
#' @param img_orig_foci cropped foci channel
#' @param watershed_radius Radius (ext variable) in watershed method used
#' in foci channel. Defaults to 1 (small)
#' @param watershed_tol Intensity tolerance for watershed method. Defaults to 0.05.
#' @return mask with coincident foci on strands
#'
get_overlap_mask<- function(strands, foci_label, watershed_stop, img_orig_foci, watershed_radius, watershed_tol){
  num_strands <- computeFeatures.shape(strands)
  num_strands <- data.frame(num_strands)
  if(watershed_stop != "off"){
    coincident_foci <- bwlabel(foci_label*strands)
  }
  else{
    foci_th <- channel(foci_label,"grey")
    coincident_foci <- watershed(bwlabel(foci_th*strands)*as.matrix(img_orig_foci),tolerance=watershed_tol, ext=watershed_radius)
  }
  return(coincident_foci)
}

#' get_foci_per_cell
#'
#' creates mask for coincident foci
#'
#' @param img_file cell's file name
#' @param offset_px, Pixel value offset used in thresholding of synaptonemal complex channel
#' @param stage, meiosis stage of interest. Currently count_foci determines
#' this with thresholding/ object properties in the synaptonemal complex channel
#' by previosly calling the get_pachytene function.
#' Note that if using this option, the count_foci function requires that the
#' input directory contains a folder called “pachytene” with the crops in it.
#' @param strands black white mask of strand channel
#' @param watershed_stop Stop default watershed method with "on"
#' @param foci_label black and white mask of foci channel
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param cell_count unique cell counter
#' @param img_orig original strand crop
#' @param img_orig_foci cropped foci channel
#' @param artificial_amp_factor amplification factor
#' @param coincident_foci mask of coincident foci
#'
#' @return number of foci per cell
#'
get_foci_per_cell <- function(img_file,offset_px,stage,strands,watershed_stop,foci_label, annotation, cell_count, img_orig, img_orig_foci, artificial_amp_factor, coincident_foci){
  coincident_df <- data.frame(computeFeatures.shape(coincident_foci))
  if(annotation == "on"){
  }
  coincident_df <- coincident_df[coincident_df$s.area,]
  ### multiply strands by foci_label
  foci_per_cell <- nrow(coincident_df)
  return(foci_per_cell)
}


#' annotate_foci_counting_adjusted
#'
#' Contains all plotting routines for count foci annotation
#'
#' @param img_file cell's file name
#' @param cell_count unique cell counter
#' @param img_orig original strand crop
#' @param img_orig_foci cropped foci channel
#' @param artificial_amp_factor amplification factor
#' @param strands black white mask of strand channel
#' @param coincident_foci mask of overlap between strand and foci channel
#' @param foci_label black and white mask of foci channel
#' @param percent_px percentage of foci mask that coincides with strand channel
#' small number indicates potentially problematic image.
#' @param alone_foci estimated number of foci that are NOT on a strand.
#' @param foci_per_cell number of foci counted per cell
#' @return displays key steps from raw image to coincident foci count
#'
annotate_foci_counting_adjusted <- function(img_file,cell_count,img_orig,img_orig_foci,artificial_amp_factor,strands,coincident_foci, foci_label,alone_foci,percent_px,foci_per_cell){
  cat("\n at file",img_file, sep = " ")
  cat("\n cell counter is", cell_count, sep= " ")
  cat("\n original images")
  plot(img_orig)
  plot(img_orig_foci)
  ch1 <-channel(img_orig,"grey")
  ch2 <- channel(artificial_amp_factor*img_orig_foci,"grey")
  bluered <- rgbImage(ch1, ch2, 0*ch1)
  cat("\n displaying resulting foci count plots. Overlay two channels:")
  plot(rgbImage(ch1,ch2,0*img_orig))
  cat("\n displaying resulting masks. Overlay two masks:")
  plot(rgbImage(strands,foci_label,0*img_orig))
  cat("\n coincident foci:")
  plot(colorLabels(coincident_foci))
  cat("\n two channels, only coincident foci")
  plot(rgbImage(strands,coincident_foci,coincident_foci))
  cat("\n which counts this many foci:",foci_per_cell, sep = " ")
  cat("\n number of alone foci",alone_foci, sep = " ")
}


#' get_C1
#'
#' calculates the statistic to compare to crisp_criteria, which determines
#' whether the foci count will be reliable
#'
#' @param C_weigh_foci_number choose crispness criteria- defaults to TRUE to use
#' C1 (weighing with number). Otherwise set to FALSE to use C2
#' @param foci_areas pixel area of each foci
#' @param foci_per_cell foci count for cell
#' @return statistic to comapre to crisp_criteria

get_C1 <- function(foci_areas, foci_per_cell, C_weigh_foci_number){
  if(C_weigh_foci_number == TRUE){
    C1 <- sd(foci_areas)/((mean(foci_areas))*(foci_per_cell+1))
  }
  else{
    C1 <- sd(foci_areas)/((mean(foci_areas))*(foci_per_cell+1)/(foci_per_cell+1))
  }
  return(C1)
}


#' get_coincident_foci
#'
#' calculates the statistic to compare to crisp_criteria, which determines
#' whether the foci count will be reliable
#' @param img_file cell's file name
#' @param cell_count unique cell counter
#' @param img_orig original strand crop
#' @param img_orig_foci cropped foci channel
#' @param C1_search TRUE or FALSE whether the image is still being modified
#' until it meets the crispness criteria
#' @param discrepant_category estimated number of foci that are NOT on a strand.
#' @param df_cells current data frame
#' @param C_weigh_foci_number choose crispness criteria- defaults to TRUE to use
#' C1 (weighing with number). Otherwise set to FALSE to use C2
#' @param stage, meiosis stage of interest. Currently count_foci determines
#' this with thresholding/ object properties in the synaptonemal complex channel
#' by previosly calling the get_pachytene function.
#' Note that if using this option, the count_foci function requires that the
#' input directory contains a folder called “pachytene” with the crops in it.
#' @param offset_px, Pixel value offset used in thresholding of synaptonemal complex channel
#' @param offset_factor, Pixel value offset used in thresholding of foci channel
#' @param brush_size, size of brush to smooth the foci channel. Should be small
#' to avoid erasing foci.
#' @param brush_sigma, sigma for Gaussian smooth of foci channel. Should be
#' small to avoid erasing foci.
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param KO_str string in filename corresponding to knockout genotype.
#' Defaults to --.
#' @param WT_str string in filename corresponding to wildtype genotype.
#' Defaults to ++.
#' @param KO_out string in output csv in genotype column, for knockout.
#' Defaults to -/-.
#' @param WT_out string in output csv in genotype column, for knockout.
#' Defaults to +/+.
#' @param watershed_stop Stop default watershed method with "on"
#' @param watershed_radius Radius (ext variable) in watershed method used
#' in foci channel. Defaults to 1 (small)
#' @param watershed_tol Intensity tolerance for watershed method. Defaults to 0.05.
#' @param crowded_foci TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have foci > 100 or so.
#' @param artificial_amp_factor Amplification of foci channel, for annotation only.
#' @param strand_amp multiplication of strand channel to make masks
#' @param disc_size size of disc for local background calculation in synaptonemal complex channel
#' @param disc_size_foci size of disc for local background calculation in foci channel
#' @param C_weigh_foci_number choose crispness criteria- defaults to TRUE to use
#' C1 (weighing with number). Otherwise set to FALSE to use C2
#' @param C1 Default crispness criteria = sd(foci_area)/(mean(foci_area)+1)
#' @param C2 Alternative crisp criteria.
#'
#' @return data frame with new row with most recent foci per cell appended
#'
#'
get_coincident_foci <- function(offset_px, offset_factor, brush_size, brush_sigma, annotation, watershed_stop, watershed_radius, watershed_tol, crowded_foci, artificial_amp_factor, strand_amp, disc_size, disc_size_foci,img_file,cell_count,img_orig,img_orig_foci,stage,WT_str,KO_str,WT_out,KO_out, C1_search,discrepant_category,C1,C2,df_cells,C_weigh_foci_number){
  strands <- make_strand_mask(offset_px, stage, img_orig, disc_size,brush_size,brush_sigma)
  color_img_strands<- colorLabels(strands, normalize = TRUE)
  num_strands <- computeFeatures.shape(strands)
  num_strands <- data.frame(num_strands)
  bg <- mean(img_orig_foci)
  if(C_weigh_foci_number == TRUE){
    crisp_criteria <- C1
  }
  else{
    crisp_criteria <- C2
  }
  while(C1_search == TRUE && discrepant_category < 2){
    foci_label <- make_foci_mask(offset_factor,bg,crowded_foci,img_orig_foci,brush_size,brush_sigma,disc_size_foci)
    foci_label <- channel(foci_label, "grey")
    foci_candidates <- data.frame(computeFeatures.shape(foci_label))
    foci_areas <- foci_candidates$s.area
    coincident_foci <- get_overlap_mask(strands, foci_label, watershed_stop, img_orig_foci, watershed_radius, watershed_tol)
    overlap_candidates <- data.frame(computeFeatures.shape(coincident_foci))
    overlap <- overlap_candidates$s.area
    percent_px <- sum(overlap)/sum(foci_areas)
    foci_per_cell <- get_foci_per_cell(img_file,offset_px,stage,strands,watershed_stop,foci_label,annotation, cell_count,img_orig, img_orig_foci, artificial_amp_factor,coincident_foci)
    C1 <- get_C1(foci_areas, foci_per_cell,C_weigh_foci_number)
    if(is.na(C1)){
      C1 <- 100
    }
    if(C1 < crisp_criteria){
      C1_search <- FALSE
    }
    else{
      discrepant_category <- discrepant_category + 1
      C1_search <- FALSE
    }
  }
  alone_foci <- nrow(foci_candidates) - foci_per_cell
  if(annotation=="on"){
    annotate_foci_counting(img_file,cell_count,img_orig,img_orig_foci,artificial_amp_factor,strands,coincident_foci, foci_label,alone_foci,percent_px,foci_per_cell)
  }
  image_mat <- as.matrix(img_orig_foci)
  image_mat <- image_mat[image_mat > 1e-06]
  df_cells <- append_data_frame(WT_str,KO_str,WT_out,KO_out,img_file,foci_areas,df_cells,cell_count,stage,foci_per_cell,image_mat,percent_px,alone_foci,discrepant_category,C1)
  return(df_cells)
  }

test_that("Creates a pachytene folder", {
  demo_path <-paste0(system.file("extdata",package = "synapsis"),"")
  auto_crop_fast(demo_path)
  SYCP3_stats <- get_pachytene(demo_path,ecc_thresh = 0.8, area_thresh = 0.04)
  folders <- list.dirs(demo_path)
  for (folder in folders){
    if(grepl("pachytene", folder)){
      folder_exists <- TRUE
    }
  }
  expect_true(folder_exists)
})

test_that("Files in pairs in pachytene folder", {
  demo_path <-paste0(system.file("extdata",package = "synapsis"),"/pachytene")
  files <- list.files(demo_path)
  file_count <- 0
  for (file in files){
    if(grepl("*SYCP3.jpeg", file)){
      file_count <- file_count + 1
    }
    if(grepl("*MLH3.jpeg", file)){
      file_count <- file_count + 1
    }
  }
  test_df <- count_foci(demo_path)
  expect_equal(file_count%%2, 0)
})

test_that("outputs data frame which has correct number of columns", {
  demo_path <-paste0(system.file("extdata",package = "synapsis"),"/")
  test_df <- count_foci(demo_path)
  expect_s3_class(test_df, "data.frame")
})



test_that("outputs data frame which has correct number of rows", {
  demo_path <-paste0(system.file("extdata",package = "synapsis"),"/")
  demo_path_2 <-paste0(system.file("extdata",package = "synapsis"),"/crops/pachytene/")
  files <- list.files(demo_path_2)
  file_count <- 0
  for (file in files){
    if(grepl("*SYCP3.jpeg", file)){
      file_count <- file_count + 1
    }
    if(grepl("*MLH3.jpeg", file)){
      file_count <- file_count + 1
    }
  }
  test_df <- count_foci(demo_path)
  expect_equal(nrow(test_df), file_count/2)
})

#' auto_crop_fast
#'
#' crop an image around each viable cell candidate.
#'
#' This function takes all images in a directory, and crops around individual
#' cells according to the antibody that stains synaptonemal complexes e.g.
#' SYCP3. First, it increases the brightness and smudges the image with a Gaussian
#' brush, and creates a mask using thresholding (get_blobs).
#' Then it deletes cell candidates in the mask deemed too large, too small,
#' or too long (keep_cells). Using the computeFeatures functions from
#' EBImage to locate centre and radius, the cropping area is determined and
#' the original image cropped. These images are saved in either a user specified
#' directory, or a crops folder at the location of the image files.
#'
#' @importFrom stats median sd
#' @importFrom EBImage bwlabel channel colorLabels computeFeatures
#' computeFeatures.basic computeFeatures.moment computeFeatures.shape
#' display filter2 makeBrush readImage rgbImage rmObjects rotate writeImage
#' distmap
#' watershed resize
#' @importFrom graphics text
#' @importFrom utils str
#' @export auto_crop_fast
#' @param img_path, path containing image data to analyse
#' @param path_out, user specified output path. Defaults to img_path
#' @param max_cell_area, Maximum pixel area of a cell candidate
#' @param min_cell_area, Minimum pixel area of a cell candidate
#' @param mean_pix, Mean pixel intensity of cell crop (in SYCP3 channel)
#' for normalisation
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param blob_factor, Contrast factor to multiply original image by before
#' smoothing/smudging
#' @param bg_blob_factor, Contrast factor to multiply original image by to
#' take background. Used prior to thresholding.
#' @param offset, Pixel value offset from bg_blob_factor. Used in thresholding
#' to make blob mask.
#' @param final_blob_amp, Contrast factor to multiply smoothed/smudged image.
#'  Used in thresholding to make blob mask.
#' @param test_amount, Optional number of first N images you want to run
#' function on. For troubleshooting/testing/variable calibration purposes.
#' @param brush_size_blob, Brush size for smudging the synaptonemal complex channel to make blobs
#' @param cell_aspect_ratio Maximum aspect ratio of blob to be defined as a cell
#' @param sigma_blob, Sigma in Gaussian brush for smudging the synaptonemal complex channel
#' to make blobs
#' @param channel1_string String appended to the files showing the channel
#' illuminating foci. Defaults to MLH3
#' @param channel2_string String appended to the files showing the channel
#' illuminating synaptonemal complexes. Defaults to SYCP3
#' @param channel3_string Optional. String appended to the files showing the
#' channel illuminating cell structures. Defaults to DAPI, if
#' third channel == "on".
#' @param third_channel Optional, defaults to "off". Set to "on" if you would
#' also like crops of the third channel.
#' @param strand_amp multiplication of strand channel for get_blobs function.
#' @param file_ext file extension of your images e.g. tif jpeg or png.
#' @param resize_l length for resized image
#' @param watershed_radius Radius (ext variable) in watershed method used
#' in strand channel. Defaults to 1 (small)
#' @param watershed_tol Intensity tolerance for watershed method. Defaults to
#' 0.05.
#' @param crowded_cells TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have many cells in a frame that almost touch
#' @param cropping_factor size of cropping window square, as factor of
#' characteristic blob radius. Defaults to 1. May need to increase if using
#' watershed.
#' @examples demo_path = paste0(system.file("extdata",package = "synapsis"))
#' auto_crop_fast(demo_path, annotation = "on", max_cell_area = 30000,
#' min_cell_area = 7000, file_ext = "tif",crowded_cells = TRUE)
#' @author Lucy McNeill
#' @return cropped synaptonemal complex and foci channels around single cells, regardless of stage

auto_crop_fast <- function(img_path,  max_cell_area = 20000, min_cell_area = 7000, mean_pix = 0.08, annotation = "off", blob_factor = 15, bg_blob_factor = 10,  offset = 0.2, final_blob_amp = 10, test_amount = 0,brush_size_blob = 51, sigma_blob = 15, channel3_string = "DAPI", channel2_string = "SYCP3", channel1_string = "MLH3", file_ext = "jpeg", third_channel = "off",cell_aspect_ratio = 2, strand_amp = 2, path_out = img_path, resize_l = 720, crowded_cells = "FALSE", watershed_radius = 50, watershed_tol = 0.2, cropping_factor =1.3)
{
  sink(nullfile())
  file_list <- list.files(img_path)
  dir.create(paste0(path_out,"/crops"))
  dir.create(paste0(path_out,"/crops-RGB"))
  cell_count <- 0
  image_count <-0
  antibody1_store <- 0
  antibody2_store <- 0
  antibody3_store <- 0
  for (img_file in file_list){
    file_base <- img_file
    filename_path_test <- paste0(img_path,"/",img_file)
    img_file <- filename_path_test
    if(third_channel == "on"){
      if(grepl(paste0('*',channel3_string,'.',file_ext,'$'),img_file)){
        file_DAPI <- img_file
        image <- readImage(file_DAPI)
        img_orig_DAPI <- channel(image, "grey")
        antibody3_store <- 1
      }
    }
    if(grepl(paste0('*',channel2_string,'.',file_ext,'$'), img_file)){
      file_sc <- img_file
      print(file)
      image <- readImage(file_sc)
      img_orig <- channel(image, "grey")
      img_orig_highres <- img_orig
      img_orig <- resize(img_orig, w = resize_l, h = resize_l)
      antibody1_store <- 1
      if(annotation == "on"){
        cat("\n displaying enhanced image of cell channel")
        plot(rgbImage(blob_factor*img_orig, 0*img_orig, 0*img_orig))
      }
    }
    if(grepl(paste0('*',channel1_string,'.',file_ext,'$'), img_file)){
      file_foci <- img_file
      image <- readImage(file_foci)
      img_orig_foci <- channel(image, "gray")
      antibody2_store <- 1
    }
    if(third_channel == "off"){
      antibody3_store <- 1
    }
    if(antibody1_store + antibody2_store + antibody3_store ==3){
      image_count <- image_count +1
      if(test_amount != 0 && image_count > test_amount){
        break
      }
      #### blur the image with get_blobs. call it on img_orig, optional offset
      blob_th <- get_blobs(strand_amp*img_orig,blob_factor, bg_blob_factor, offset,final_blob_amp,brush_size_blob, sigma_blob,  watershed_tol, watershed_radius, crowded_cells, annotation)
      if(crowded_cells != "TRUE"){
        blob_label <- bwlabel(blob_th)
        blob_label <- channel(blob_label, "gray")
        candidate <- bwlabel(blob_label)
      }
      else{
        candidate <- blob_th
      }

      ## remove things that aren't cells
      retained <- keep_cells(candidate, max_cell_area, min_cell_area,cell_aspect_ratio, crowded_cells, annotation)
      ### crop over each cell
      ## Loop over all objects in this final "removed" image
      if(crowded_cells == "TRUE"){
        ## do watershed on the mask again
        y <- distmap(retained)
        retained <- watershed(y)
        ##
        x_final <- computeFeatures.shape(retained)
        moment_info <- computeFeatures.moment(retained,as.matrix(img_orig))
        x_final <- data.frame(x_final)
        moment_info <- as.data.frame(moment_info)
        OOI_final <- nrow(x_final)
        counter_final <- 0
        r_max <- x_final$s.radius.max
        cx <- moment_info$m.cx
        cy <- moment_info$m.cy
      }
      else{
        x_final <- computeFeatures.shape(retained)
        moment_info <- computeFeatures.moment(retained,as.matrix(img_orig))
        x_final <- data.frame(x_final)
        moment_info <- as.data.frame(moment_info)
        OOI_final <- nrow(x_final)
        counter_final <- 0
        r_max <- x_final$s.radius.max
        cx <- moment_info$m.cx
        cy <- moment_info$m.cy
      }
      # looping through each object to crop
      while(counter_final<OOI_final){
        counter_final <- counter_final+1
        ### row of interest is the counter_final'th row of x_final
        cell_count <- cell_count +1
        sink()
        if(third_channel=="on"){
          crop_single_object_fast(retained,OOI_final,counter_final,img_orig,img_orig_foci,img_orig_DAPI,file_sc,file_foci,file_DAPI,cell_count, mean_pix, annotation, file_base, img_path, r_max, cx, cy,channel3_string,channel2_string,channel1_string,file_ext,third_channel,path_out, img_orig_highres, resize_l,crowded_cells, cropping_factor)
        }
        else{
          crop_single_object_fast(retained,OOI_final,counter_final,img_orig,img_orig_foci,img_orig_foci,file_sc,file_foci,file_foci,cell_count, mean_pix, annotation, file_base, img_path, r_max, cx, cy,channel3_string,channel2_string,channel1_string,file_ext,third_channel,path_out, img_orig_highres, resize_l,crowded_cells, cropping_factor)
        }
      }
      antibody1_store <- 0
      antibody2_store <- 0
      antibody3_store <- 0
    }
  }
crop_count <- nrow(as.data.frame(list.files(paste0(img_path,"/crops-RGB/"))))
cat("out of",image_count,"images, we got",crop_count,"viable cells \n", sep = " ")
}


#' crop_single_object_fast
#'
#' Creates mask for every individual cell candidate in mask
#'
#' @param retained Mask of cell candidates which meet size criteria.
#' After smoothing/smudging and thresholding.
#' @param OOI_final, Objects of interest count. Total number of cell
#' candidates in retained.
#' @param counter_final, Counter for single cell we are focussing on. Remove
#' all other cells where counter_single not equal to counter_final.
#' @param img_orig, description
#' @param img_orig_foci, description
#' @param img_orig_DAPI, description
#' @param file_sc, filename of synaptonemal complex channel image
#' @param file_foci, filename of foci channel image
#' @param file_DAPI, filename of DAPI channel image
#' @param cell_count, counter for successful crops around cells
#' @param mean_pix, Mean pixel intensity of cell crop (in SYCP3 channel)
#' for normalisation
#' @param r_max maximum radius of blob for cropping
#' @param cx centre of blob x
#' @param cy centre of blob y
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param file_base, filename base common to all three channels
#' i.e. without -MLH3.jpeg etc.
#' @param img_path, path containing image data to analyse
#' @param path_out, user specified output path. Defaults to img_path
#' @param channel1_string String appended to the files showing the channel
#' illuminating foci. Defaults to MLH3
#' @param channel2_string String appended to the files showing the channel
#' illuminating synaptonemal complexes. Defaults to SYCP3
#' @param channel3_string Optional. String appended to the files showing the
#' channel illuminating cell structures. Defaults to DAPI,
#' if third channel == "on".
#' @param third_channel Optional, defaults to "off". Set to "on" if you would
#' also like crops of the third channel.
#' @param img_orig_highres the original strand image with original resolution
#' @param file_ext file extension of your images e.g. tif jpeg or png.
#' @param resize_l length of square to resize original image to.
#' @param crowded_cells TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have many cells in a frame that almost touch
#' @param cropping_factor size of cropping window square, as factor of
#' characteristic blob radius. Defaults to 1. May need to increase if using
#' watershed.
#' @return Crops around all candidates in both channels
#'
crop_single_object_fast <- function(retained, OOI_final,counter_final,img_orig,img_orig_foci,img_orig_DAPI="blank",file_sc,file_foci,file_DAPI = "blank",cell_count, mean_pix, annotation, file_base, img_path, r_max, cx, cy,channel3_string,channel2_string,channel1_string,file_ext,third_channel,path_out, img_orig_highres, resize_l, crowded_cells,cropping_factor){
  tmp_img <- retained
  ###added
  y <- distmap(tmp_img)
  blob_th <- watershed(y)
  candidate <- blob_th
  ### end added
  ## have a single object
  ### delete all other objects
  counter_single <- 0
  # looping over all other objects to crop
  if(crowded_cells == "TRUE"){
    while(counter_single < OOI_final){
      counter_single <- counter_single + 1
      # iteratively remove all other objects
      if(counter_single != counter_final){
        retained <- as.numeric(retained)*rmObjects(candidate, counter_single, reenumerate = TRUE)
        #tmp_img <- as.numeric(tmp_img)*rmObjects(bwlabel(retained), counter_single, reenumerate = TRUE)
      }
    }
    tmp_img <- retained
  }
  else{
    while(counter_single < OOI_final){
      counter_single <- counter_single + 1
      # iteratively remove all other objects
      if(counter_single != counter_final){
        tmp_img <- as.numeric(tmp_img)*rmObjects(bwlabel(retained), counter_single, reenumerate = TRUE)
      }
    }
  }

  #### resize your images here?
  dim_orig <- dim(img_orig_highres)
  new_l <- as.integer(dim_orig[1])
  noise_gone_highres <- bwlabel(resize(tmp_img, h =  new_l, w =  new_l))*as.matrix(img_orig_highres)
  noise_gone_foci <- bwlabel(resize(tmp_img, h =  new_l, w =  new_l))*as.matrix(img_orig_foci)
  if(third_channel == "on"){
    noise_gone_DAPI <- bwlabel(resize(tmp_img, h =  new_l, w =  new_l))*as.matrix(img_orig_DAPI)
  }
  crop_r_highres <- round(cropping_factor*floor(r_max[counter_final]*round( new_l/resize_l)))
  cx_highres <- cx[counter_final]*( new_l/resize_l)
  cy_highres <- cy[counter_final]*( new_l/resize_l)
  top_left_x_highres <- floor(cx_highres-crop_r_highres)
  top_left_y_highres <- floor(cy_highres-crop_r_highres)
  bottom_left_x_highres <- floor(cx_highres-crop_r_highres)
  bottom_left_y_highres <- floor(cy_highres+crop_r_highres)
  bottom_right_x_highres <- floor(cx_highres+crop_r_highres)
  bottom_right_y_highres <- floor(cy_highres+crop_r_highres)
  top_right_x_highres <- floor(cx_highres-crop_r_highres)
  top_right_y_highres <- floor(cy_highres+crop_r_highres)
  ## crop image
  ix <- bottom_left_x_highres:bottom_right_x_highres
  iy <- top_left_y_highres:bottom_left_y_highres
  ####### end high res stuff
  #########

### cropping finished
  ## cropping part
  tryCatch({
    img_path_out <- path_out
    new_img <- noise_gone_highres[ix, iy]
    ## want all images to have the same mean (mean_pix)
    orig_mean <- mean(new_img)
    mean_factor <- mean_pix/orig_mean
    new_img <- new_img*mean_factor
    file_stub <- paste0('-',channel2_string,'.',file_ext)
    file_sc <- gsub(file_stub,'', file_base)
    filename_crop <- paste0(img_path_out,"/crops/", file_sc,"-crop-",cell_count,file_stub)
    writeImage(new_img, filename_crop)
    new_img_foci <- noise_gone_foci[ix, iy]
    file_stub <- paste0('-',channel1_string,'.',file_ext)
    file_foci <- gsub(file_stub,'', file_foci)
    filename_crop_foci <- paste0(img_path_out,"/crops/", file_sc,"-crop-",cell_count,file_stub)
    writeImage(new_img_foci, filename_crop_foci)
    ### add RGB channel
    ch1 <-channel(new_img,"grey")
    ch2 <- channel(new_img_foci,"grey")
    RGB_img <- rgbImage(ch1,ch2,0*ch1)
    filename_crop_RGB <- paste0(img_path_out,"/crops-RGB/", file_sc,"-crop-",cell_count,file_stub)
    writeImage(RGB_img, filename_crop_RGB)
    if(third_channel == "on"){
      new_img_DAPI <- noise_gone_DAPI[ix, iy]
      file_stub <- paste0('-',channel3_string,'.',file_ext)
      file_DAPI <- gsub(file_stub,'', file_DAPI)
      filename_crop_DAPI <- paste0(img_path_out,"/crops/", file_sc,"-crop-",cell_count,file_stub)
      writeImage(new_img_DAPI, filename_crop_DAPI)
    }

    if(annotation=="on"){
      print("from the file:")
      print(file_sc)
      plot(img_orig)
      print("I cropped this cell:")
      plot(new_img)
      print("using this mask")
      plot(tmp_img)
      print("whose cell number is")
      print(cell_count)
    }
    #### strand related stuff here
  },
  error = function(e) {
    if(annotation=="on"){
      #str(e) # #prints structure of exception
      print("couldn't crop it since cell is on the edge. Neglected the following mask of a cell candidate:")
      plot(tmp_img)
      plot(noise_gone_highres)
    }
  }
  )
}


#' get_blobs
#'
#' Makes mask of all objects bright enough to be classified as a cell
#' cadidate
#'
#'
#'
#' @param img_orig Original image
#'
#' @param blob_factor, Contrast factor to multiply original image by before
#' smoothing/smudging
#' @param bg_blob_factor, Contrast factor to multiply original image by to take
#' background. Used prior to thresholding.
#' @param offset, Pixel value offset from bg_blob_factor. Used in thresholding
#' to make blob mask.
#' @param final_blob_amp, Contrast factor to multiply smoothed/smudged image.
#' Used in thresholding to make blob mask.
#' @param brush_size_blob, Brush size for smudging the synaptonemal complex channel to make blobs
#' @param sigma_blob, Sigma in Gaussian brush for smudging the synaptonemal complex channel to
#' make blobs
#' @param watershed_radius Radius (ext variable) in watershed method used
#' in strand channel. Defaults to 1 (small)
#' @param watershed_tol Intensity tolerance for watershed method. Defaults to 0.05.
#' @param crowded_cells TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' have many cells in a frame that almost touch
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' have many cells in a frame that almost touch
#' @return Mask with cell candidates

get_blobs <- function(img_orig, blob_factor, bg_blob_factor, offset,final_blob_amp, brush_size_blob,sigma_blob, watershed_tol, watershed_radius, crowded_cells,annotation){
  thresh <- blob_factor*img_orig
  # subfunction: big blur to blobs
  img_tmp_sc <- img_orig
  img_tmp <- thresh
  w <- makeBrush(size = brush_size_blob, shape = 'gaussian', sigma = sigma_blob)
  img_flo <- filter2(img_tmp, w)
  ## default amplification
  bg <- mean(bg_blob_factor*img_tmp)
  blob_th <- final_blob_amp*img_flo > bg + offset

  if(crowded_cells != "TRUE"){
    blob_th <- final_blob_amp*img_flo > bg + offset

  }
  else{
    y <- distmap(blob_th)
    blob_th <- watershed(y)
  }
  if(annotation == "on"){
    cat("\n here is the mask")
    if(crowded_cells == "TRUE"){
      tryCatch({
        if(nrow(data.frame(blob_th)) > 0){
          plot(colorLabels(blob_th))
        }
      },
      error = function(e) {
      }
      )
    }
    else{
      plot(blob_th)
    }

  }

  return(blob_th)
}


#' keep_cells
#'
#' Deletes objects in mask which are too small, large, oblong
#' i.e. unlikely to be a cell
#'
#' @param candidate Mask of individual cell candidates
#' @param max_cell_area, Maximum pixel area of a cell candidate
#' @param min_cell_area, Minimum pixel area of a cell candidate
#' @param cell_aspect_ratio Maximum aspect ratio of blob to be defined as a cell
#' @param crowded_cells TRUE or FALSE, defaults to FALSE. Set to TRUE if you
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' have many cells in a frame that almost touch

#' @return Mask of cell candidates which meet size criteria
keep_cells <- function(candidate, max_cell_area, min_cell_area, cell_aspect_ratio, crowded_cells, annotation){

  # delete everything that's too small
  colorimg<- colorLabels(candidate, normalize = TRUE)
  x <- computeFeatures.shape(candidate)
  x <- data.frame(x)
  OOI <- nrow(x)
  counter <- 0
  retained <- candidate
  while(counter<OOI){
    counter <- counter+1
    pixel_area <- x$s.area[counter]
    semi_maj <- x$s.radius.max[counter]
    semi_min <- x$s.radius.min[counter]
    # if statement checking if it's the wrong area
    if(pixel_area> max_cell_area | pixel_area < min_cell_area){
      retained <- as.numeric(retained)*rmObjects(candidate, counter, reenumerate = TRUE)
    }
    ## if statement checking that it's not too long i.e. not at edge.
    if(semi_maj/semi_min > cell_aspect_ratio & is.na(semi_maj/semi_min)==FALSE){
      retained <- as.numeric(retained)*rmObjects(candidate, counter, reenumerate = TRUE)
    }
  }
  if(annotation == "on"){
    cat("\n displaying the retained cells in mask (correct size/ shape)")
    if(crowded_cells == "TRUE"){
      tryCatch({
        if(nrow(data.frame(retained)) > 0){
          plot(retained)
        }
      },
      error = function(e) {
      }
      )

    }
    else{
      plot(retained)
    }
  }
  retained <- bwlabel(retained)
  return(retained)
}

test_that("Creates a crops folder", {
  demo_path <-paste0(system.file("extdata",package = "synapsis"),"")
  auto_crop_fast(demo_path)
  folders <- list.dirs(demo_path)
  for (folder in folders){
    if(grepl("crops", folder)){
      folder_exists <- TRUE
    }
  }
  expect_true(folder_exists)
})

#' get_pachytene
#'
#' Identifies crops in pachytene
#'
#' This function takes the crops make by auto_crop fast, and determines the
#' number of synaptonemal complex candidates by considering the local background
#' and using EBImage functions. In general, very bright objects which contrast
#' highly with the background will be classified as the same object. Dim objects
#' will likely be classified as many different objects. If the number of objects
#' is too high compared to the species number (species_num) then the cell is
#' determined to not be in pachytene. Note that this function has been optimized
#' for mouse cells which can be very well spread / separated.
#'
#' @export get_pachytene
#' @param img_path, path containing crops analyse
#' @param path_out, user specified output path. Defaults to img_path
#' @param species_num, number of chromosomes in the species
#' @param offset, Pixel value offset used in therholding for the synaptonemal complex (SYCP3) channel
#' @param ecc_thresh, The minimum average eccentricity of all objects in mask determined by computefeatures, for a cell to be pachytene.
#' @param area_thresh, The minimum ratio of pixels included in mask to total, for a cell to be classified as pachytene.
#' @param channel1_string String appended to the files showing the channel illuminating foci. Defaults to MLH3
#' @param channel2_string String appended to the files showing the channel illuminating synaptonemal complexes. Defaults to SYCP3
#' @param file_ext file extension of your images e.g. tiff jpeg or png.
#' @param annotation, Choice to output pipeline choices (recommended to knit)
#' @param KO_str string in filename corresponding to knockout genotype. Defaults to --.
#' @param WT_str string in filename corresponding to wildtype genotype. Defaults to ++.
#' @param KO_out string in output csv in genotype column, for knockout. Defaults to -/-.
#' @param WT_out string in output csv in genotype column, for knockout. Defaults to +/+.
#' @param resize_l length of resized square cell image.
#' @param artificial_amp_factor Amplification of foci channel, for RGB output files. Deaults to 3.
#' @param strand_amp multiplication of strand channel.
#' @examples demo_path = paste0(system.file("extdata",package = "synapsis"))
#' SYCP3_stats <- get_pachytene(demo_path,ecc_thresh = 0.8, area_thresh = 0.04, annotation = "on")
#' @author Lucy McNeill
#' @return Pairs of foci and synaptonemal channel crops for pachytene
#'


get_pachytene <- function(img_path, species_num = 20, offset = 0.2,ecc_thresh = 0.85, area_thresh = 0.06, annotation = "off", channel2_string = "SYCP3", channel1_string = "MLH3",file_ext = "jpeg", KO_str = "--",WT_str = "++",KO_out = "-/-", WT_out = "+/+", path_out = img_path, artificial_amp_factor=3, strand_amp = 2, resize_l = 120)
{
  cell_count <- 0
  image_count <-0
  antibody1_store <- 0
  antibody2_store <- 0
  pachytene_count <- 0
  max_obj <- species_num + round(0.1*species_num)
  df_cols <- c("filename","cell_no","genotype", "px_mask","px_total", "px_fraction", "mean_ecc","mean_ratio","skew","sd_bright_px","stage_classification")
  df_cells <- data.frame(matrix(ncol = length(df_cols), nrow = 0))
  colnames(df_cells) <- df_cols
  img_path_new <- paste0(img_path,"/crops")
  if(img_path == path_out){
    img_path_out <- img_path_new
    dir.create(paste0(img_path_new,"/pachytene"))
    dir.create(paste0(img_path_new,"/pachytene-RGB"))
  }
  else{
    img_path_out <- path_out
    dir.create(paste0(path_out,"/pachytene"))
    dir.create(paste0(path_out,"/pachytene-RGB"))
  }

  file_list <- list.files(img_path_new)
  for (img_file in file_list){
    file_base <- img_file
    filename_path_test <- paste0(img_path,"/crops/", img_file)
    img_file <- filename_path_test
    if(grepl(paste0('*',channel2_string,'.',file_ext,'$'), img_file)){
      file_sc <- img_file
      file_base_sc <- file_base
      image_count <- image_count +1
      image <- readImage(file_sc)
      img_orig_highres <- channel(image, "grey")
      img_orig <- channel(strand_amp*image, "grey")
      img_orig <- resize(img_orig, w = resize_l, h = resize_l)
      antibody1_store <- 1
    }
    if(grepl(paste0('*',channel1_string,'.',file_ext,'$'), img_file)){
      file_base_foci <- file_base
      file_foci <- img_file
      image <- readImage(file_foci)
      img_orig_foci <- channel(image, "gray")
      antibody2_store <- 1
    }
    if(antibody1_store + antibody2_store ==2){
      antibody1_store <- 0
      antibody2_store <- 0
      new_img<-img_orig
      #### now see which have the right amount of strands
      disc <- makeBrush(21, "disc")
      disc <- disc / sum(disc)
      localBackground <- filter2(new_img, disc)
      thresh_crop <- (new_img - localBackground > offset)
      strands <- bwlabel(thresh_crop)
      color_img_strands<- colorLabels(strands, normalize = TRUE)
      num_strands <- computeFeatures.shape(strands)
      num_strands <- data.frame(num_strands)
      #### segment the strands
      if (nrow(num_strands)<max_obj && nrow(num_strands)>3){
        cell_count <- cell_count + 1
        ### identified a good image. count foci
        ### data frame stuff
        if(grepl( WT_str, img_file, fixed = TRUE) == TRUE){
          genotype <- WT_out
        }
        if(grepl( KO_str, img_file, fixed = TRUE) == TRUE){
          genotype <- KO_out
        }
        image_mat <- as.matrix(new_img)
        image_mat <- image_mat[image_mat > 1e-01]
        mean_ratio <- median(image_mat)/mean(image_mat)
        skew <- (median(image_mat)-mean(image_mat))/sd(image_mat)
        ### look at properties of the foci.
        SC_candidates <- computeFeatures.shape(strands)
        SC_candidates <- data.frame(SC_candidates)
        SC_areas <- SC_candidates$s.area
        moment_info <- computeFeatures.moment(bwlabel(strands),as.matrix(new_img))
        moment_info <- as.data.frame(moment_info)
        ## might actually want to find the real centre first..
        ### data frame stuff ends
        dim_img <- nrow(new_img)
        num_px <- dim_img*dim_img
        px_mask <- sum(SC_areas)
        px_total <- num_px
        px_fraction <- px_mask/px_total
        mean_ecc <- mean(moment_info$m.eccentricity)
        stage_classification <- "pachytene"
        sd_bright_px <- sd(image_mat)
        if(mean_ecc > ecc_thresh){
          if(px_fraction > area_thresh){
            stage_classification <- "pachytene"
            df_cells <- rbind(df_cells,t(c(img_file,cell_count,genotype,px_mask, px_total,px_fraction, mean_ecc,mean_ratio,skew,sd_bright_px,stage_classification)))
            pachytene_count <- pachytene_count + 1
            file_sc <- tools::file_path_sans_ext(file_base_sc)
            filename_crop <- paste0(img_path_out,"/pachytene/", file_sc,'.',file_ext)
            writeImage(img_orig_highres, filename_crop)
            if(annotation == "on"){
              print("decided the following is pachytene")
              display(img_orig_highres)
            }
            file_foci <- tools::file_path_sans_ext(file_base_foci)
            filename_crop_foci <- paste0(img_path_out,"/pachytene/", file_foci,'.',file_ext)
            writeImage(img_orig_foci, filename_crop_foci)
            ### add RGB channel
            ch1 <-channel(img_orig_highres,"grey")
            ch2 <- channel(img_orig_foci,"grey")
            RGB_img <- rgbImage(ch1,ch2,0*ch1)
            filename_crop_RGB <- paste0(img_path_out,"/pachytene-RGB/", file_sc,'.',file_ext)
            writeImage(RGB_img, filename_crop_RGB)
          }
        }
      }
    }
  }
cat("number of cells kept",pachytene_count, sep = " ")
colnames(df_cells) <- df_cols
return(df_cells)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{make_strand_mask}
\alias{make_strand_mask}
\title{make_strand_mask}
\usage{
make_strand_mask(
  offset_px,
  stage,
  img_orig,
  disc_size,
  brush_size,
  brush_sigma
)
}
\arguments{
\item{offset_px, }{Pixel value offset used in thresholding of synaptonemal complex channel}

\item{stage, }{meiosis stage of interest. Currently count_foci determines
this with thresholding/ object properties in the synaptonemal complex channel
by previosly calling the get_pachytene function.
Note that if using this option, the count_foci function requires that the
input directory contains a folder called “pachytene” with the crops in it.}

\item{img_orig}{original strand crop}

\item{disc_size}{size of disc for local background calculation in synaptonemal complex channel}

\item{brush_size, }{size of brush to smooth the foci channel. Should be small
to avoid erasing foci.}

\item{brush_sigma, }{sigma for Gaussian smooth of foci channel. Should be
small to avoid erasing foci.}
}
\value{
strand mask
}
\description{
creates strand mask for strand channel crop
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auto_crop_fast.R
\name{crop_single_object_fast}
\alias{crop_single_object_fast}
\title{crop_single_object_fast}
\usage{
crop_single_object_fast(
  retained,
  OOI_final,
  counter_final,
  img_orig,
  img_orig_foci,
  img_orig_DAPI = "blank",
  file_sc,
  file_foci,
  file_DAPI = "blank",
  cell_count,
  mean_pix,
  annotation,
  file_base,
  img_path,
  r_max,
  cx,
  cy,
  channel3_string,
  channel2_string,
  channel1_string,
  file_ext,
  third_channel,
  path_out,
  img_orig_highres,
  resize_l,
  crowded_cells,
  cropping_factor
)
}
\arguments{
\item{retained}{Mask of cell candidates which meet size criteria.
After smoothing/smudging and thresholding.}

\item{OOI_final, }{Objects of interest count. Total number of cell
candidates in retained.}

\item{counter_final, }{Counter for single cell we are focussing on. Remove
all other cells where counter_single not equal to counter_final.}

\item{img_orig, }{description}

\item{img_orig_foci, }{description}

\item{img_orig_DAPI, }{description}

\item{file_sc, }{filename of synaptonemal complex channel image}

\item{file_foci, }{filename of foci channel image}

\item{file_DAPI, }{filename of DAPI channel image}

\item{cell_count, }{counter for successful crops around cells}

\item{mean_pix, }{Mean pixel intensity of cell crop (in SYCP3 channel)
for normalisation}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{file_base, }{filename base common to all three channels
i.e. without -MLH3.jpeg etc.}

\item{img_path, }{path containing image data to analyse}

\item{r_max}{maximum radius of blob for cropping}

\item{cx}{centre of blob x}

\item{cy}{centre of blob y}

\item{channel3_string}{Optional. String appended to the files showing the
channel illuminating cell structures. Defaults to DAPI,
if third channel == "on".}

\item{channel2_string}{String appended to the files showing the channel
illuminating synaptonemal complexes. Defaults to SYCP3}

\item{channel1_string}{String appended to the files showing the channel
illuminating foci. Defaults to MLH3}

\item{file_ext}{file extension of your images e.g. tif jpeg or png.}

\item{third_channel}{Optional, defaults to "off". Set to "on" if you would
also like crops of the third channel.}

\item{path_out, }{user specified output path. Defaults to img_path}

\item{img_orig_highres}{the original strand image with original resolution}

\item{resize_l}{length of square to resize original image to.}

\item{crowded_cells}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have many cells in a frame that almost touch}

\item{cropping_factor}{size of cropping window square, as factor of
characteristic blob radius. Defaults to 1. May need to increase if using
watershed.}
}
\value{
Crops around all candidates in both channels
}
\description{
Creates mask for every individual cell candidate in mask
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_pachytene.R
\name{get_pachytene}
\alias{get_pachytene}
\title{get_pachytene}
\usage{
get_pachytene(
  img_path,
  species_num = 20,
  offset = 0.2,
  ecc_thresh = 0.85,
  area_thresh = 0.06,
  annotation = "off",
  channel2_string = "SYCP3",
  channel1_string = "MLH3",
  file_ext = "jpeg",
  KO_str = "--",
  WT_str = "++",
  KO_out = "-/-",
  WT_out = "+/+",
  path_out = img_path,
  artificial_amp_factor = 3,
  strand_amp = 2,
  resize_l = 120
)
}
\arguments{
\item{img_path, }{path containing crops analyse}

\item{species_num, }{number of chromosomes in the species}

\item{offset, }{Pixel value offset used in therholding for the synaptonemal complex (SYCP3) channel}

\item{ecc_thresh, }{The minimum average eccentricity of all objects in mask determined by computefeatures, for a cell to be pachytene.}

\item{area_thresh, }{The minimum ratio of pixels included in mask to total, for a cell to be classified as pachytene.}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{channel2_string}{String appended to the files showing the channel illuminating synaptonemal complexes. Defaults to SYCP3}

\item{channel1_string}{String appended to the files showing the channel illuminating foci. Defaults to MLH3}

\item{file_ext}{file extension of your images e.g. tiff jpeg or png.}

\item{KO_str}{string in filename corresponding to knockout genotype. Defaults to --.}

\item{WT_str}{string in filename corresponding to wildtype genotype. Defaults to ++.}

\item{KO_out}{string in output csv in genotype column, for knockout. Defaults to -/-.}

\item{WT_out}{string in output csv in genotype column, for knockout. Defaults to +/+.}

\item{path_out, }{user specified output path. Defaults to img_path}

\item{artificial_amp_factor}{Amplification of foci channel, for RGB output files. Deaults to 3.}

\item{strand_amp}{multiplication of strand channel.}

\item{resize_l}{length of resized square cell image.}
}
\value{
Pairs of foci and synaptonemal channel crops for pachytene
}
\description{
Identifies crops in pachytene
}
\details{
This function takes the crops make by auto_crop fast, and determines the
number of synaptonemal complex candidates by considering the local background
and using EBImage functions. In general, very bright objects which contrast
highly with the background will be classified as the same object. Dim objects
will likely be classified as many different objects. If the number of objects
is too high compared to the species number (species_num) then the cell is
determined to not be in pachytene. Note that this function has been optimized
for mouse cells which can be very well spread / separated.
}
\examples{
demo_path = paste0(system.file("extdata",package = "synapsis"))
SYCP3_stats <- get_pachytene(demo_path,ecc_thresh = 0.8, area_thresh = 0.04, annotation = "on")
}
\author{
Lucy McNeill
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{count_foci}
\alias{count_foci}
\title{count_foci}
\usage{
count_foci(
  img_path,
  stage = "none",
  offset_px = 0.2,
  offset_factor = 2,
  brush_size = 3,
  brush_sigma = 3,
  foci_norm = 0.01,
  annotation = "off",
  channel2_string = "SYCP3",
  channel1_string = "MLH3",
  file_ext = "jpeg",
  KO_str = "--",
  WT_str = "++",
  KO_out = "-/-",
  WT_out = "+/+",
  watershed_stop = "off",
  watershed_radius = 1,
  watershed_tol = 0.05,
  crowded_foci = TRUE,
  artificial_amp_factor = 1,
  strand_amp = 2,
  min_foci = -1,
  disc_size = 51,
  modify_problematic = "off",
  disc_size_foci = 5,
  C1 = 0.02,
  C2 = 0.46,
  C_weigh_foci_number = TRUE
)
}
\arguments{
\item{img_path, }{path containing crops to analyse}

\item{stage, }{meiosis stage of interest. Currently count_foci determines
this with thresholding/ object properties in the synaptonemal complex channel
by previosly calling the get_pachytene function.
Note that if using this option, the count_foci function requires that the
input directory contains a folder called “pachytene” with the crops in it.}

\item{offset_px, }{Pixel value offset used in thresholding of synaptonemal complex channel}

\item{offset_factor, }{Pixel value offset used in thresholding of foci channel}

\item{brush_size, }{size of brush to smooth the foci channel. Should be small
to avoid erasing foci.}

\item{brush_sigma, }{sigma for Gaussian smooth of foci channel. Should be
small to avoid erasing foci.}

\item{foci_norm, }{Mean intensity to normalise all foci channels to.}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{channel2_string}{String appended to the files showing the channel
illuminating synaptonemal complexes. Defaults to SYCP3}

\item{channel1_string}{String appended to the files showing the channel
illuminating foci. Defaults to MLH3}

\item{file_ext}{file extension of your images e.g. tiff jpeg or png.}

\item{KO_str}{string in filename corresponding to knockout genotype.
Defaults to --.}

\item{WT_str}{string in filename corresponding to wildtype genotype.
Defaults to ++.}

\item{KO_out}{string in output csv in genotype column, for knockout.
Defaults to -/-.}

\item{WT_out}{string in output csv in genotype column, for knockout.
Defaults to +/+.}

\item{watershed_stop}{Stop default watershed method with "on"}

\item{watershed_radius}{Radius (ext variable) in watershed method used
in foci channel. Defaults to 1 (small)}

\item{watershed_tol}{Intensity tolerance for watershed method. Defaults to 0.05.}

\item{crowded_foci}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have foci > 100 or so.}

\item{artificial_amp_factor}{Amplification of foci channel, for annotation only.}

\item{strand_amp}{multiplication of strand channel to make masks}

\item{min_foci}{minimum pixel area for a foci. Depends on your dpi etc. Defaults to 4}

\item{disc_size}{size of disc for local background calculation in synaptonemal complex channel}

\item{modify_problematic}{option for synapsis to try and "save" images which
have likely been counted incorrectly due to a number of reasons. Default
settings are optimized for mouse pachytene. Defaults to "off"}

\item{disc_size_foci}{size of disc for local background calculation in foci channel}

\item{C1}{Default crispness criteria = sd(foci_area)/(mean(foci_area)+1)}

\item{C2}{Alternative crisp criteria.}

\item{C_weigh_foci_number}{choose crispness criteria- defaults to TRUE to use
C1 (weighing with number). Otherwise set to FALSE to use C2}
}
\value{
data frame with foci count per cell
}
\description{
Calculates coincident foci in synaptonemal complex and foci channel, per cell
}
\details{
In this function, masks for the synaptonemal complex (SC) and foci channel
are created from the saved crops of single/individual cells.
These masks are computed using (optional) input parameters related
to meiosis stage/ how well spread chromosomes are (for the former)
and related to smoothing, thresholding and how "crowded" foci are for the
latter. Finally, these two masks are multiplied, and the number of
objects found with EBImage's computeFeatures are the colocalizing foci.

The file, cell number, foci count etc. are output as a data frame.
}
\examples{
demo_path = paste0(system.file("extdata",package = "synapsis"))
foci_counts <- count_foci(demo_path,offset_factor = 3, brush_size = 3,
brush_sigma = 3, annotation = "on",stage = "pachytene")
}
\author{
Lucy McNeill
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{get_overlap_mask}
\alias{get_overlap_mask}
\title{get_overlap_mask}
\usage{
get_overlap_mask(
  strands,
  foci_label,
  watershed_stop,
  img_orig_foci,
  watershed_radius,
  watershed_tol
)
}
\arguments{
\item{strands}{black white mask of strand channel}

\item{foci_label}{black and white mask of foci channel}

\item{watershed_stop}{Stop default watershed method with "on"}

\item{img_orig_foci}{cropped foci channel}

\item{watershed_radius}{Radius (ext variable) in watershed method used
in foci channel. Defaults to 1 (small)}

\item{watershed_tol}{Intensity tolerance for watershed method. Defaults to 0.05.}
}
\value{
mask with coincident foci on strands
}
\description{
creates mask for coincident foci
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{get_coincident_foci}
\alias{get_coincident_foci}
\title{get_coincident_foci}
\usage{
get_coincident_foci(
  offset_px,
  offset_factor,
  brush_size,
  brush_sigma,
  annotation,
  watershed_stop,
  watershed_radius,
  watershed_tol,
  crowded_foci,
  artificial_amp_factor,
  strand_amp,
  disc_size,
  disc_size_foci,
  img_file,
  cell_count,
  img_orig,
  img_orig_foci,
  stage,
  WT_str,
  KO_str,
  WT_out,
  KO_out,
  C1_search,
  discrepant_category,
  C1,
  C2,
  df_cells,
  C_weigh_foci_number
)
}
\arguments{
\item{offset_px, }{Pixel value offset used in thresholding of synaptonemal complex channel}

\item{offset_factor, }{Pixel value offset used in thresholding of foci channel}

\item{brush_size, }{size of brush to smooth the foci channel. Should be small
to avoid erasing foci.}

\item{brush_sigma, }{sigma for Gaussian smooth of foci channel. Should be
small to avoid erasing foci.}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{watershed_stop}{Stop default watershed method with "on"}

\item{watershed_radius}{Radius (ext variable) in watershed method used
in foci channel. Defaults to 1 (small)}

\item{watershed_tol}{Intensity tolerance for watershed method. Defaults to 0.05.}

\item{crowded_foci}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have foci > 100 or so.}

\item{artificial_amp_factor}{Amplification of foci channel, for annotation only.}

\item{strand_amp}{multiplication of strand channel to make masks}

\item{disc_size}{size of disc for local background calculation in synaptonemal complex channel}

\item{disc_size_foci}{size of disc for local background calculation in foci channel}

\item{img_file}{cell's file name}

\item{cell_count}{unique cell counter}

\item{img_orig}{original strand crop}

\item{img_orig_foci}{cropped foci channel}

\item{stage, }{meiosis stage of interest. Currently count_foci determines
this with thresholding/ object properties in the synaptonemal complex channel
by previosly calling the get_pachytene function.
Note that if using this option, the count_foci function requires that the
input directory contains a folder called “pachytene” with the crops in it.}

\item{WT_str}{string in filename corresponding to wildtype genotype.
Defaults to ++.}

\item{KO_str}{string in filename corresponding to knockout genotype.
Defaults to --.}

\item{WT_out}{string in output csv in genotype column, for knockout.
Defaults to +/+.}

\item{KO_out}{string in output csv in genotype column, for knockout.
Defaults to -/-.}

\item{C1_search}{TRUE or FALSE whether the image is still being modified
until it meets the crispness criteria}

\item{discrepant_category}{estimated number of foci that are NOT on a strand.}

\item{C1}{Default crispness criteria = sd(foci_area)/(mean(foci_area)+1)}

\item{C2}{Alternative crisp criteria.}

\item{df_cells}{current data frame}

\item{C_weigh_foci_number}{choose crispness criteria- defaults to TRUE to use
C1 (weighing with number). Otherwise set to FALSE to use C2}
}
\value{
data frame with new row with most recent foci per cell appended
}
\description{
calculates the statistic to compare to crisp_criteria, which determines
whether the foci count will be reliable
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{get_foci_per_cell}
\alias{get_foci_per_cell}
\title{get_foci_per_cell}
\usage{
get_foci_per_cell(
  img_file,
  offset_px,
  stage,
  strands,
  watershed_stop,
  foci_label,
  annotation,
  cell_count,
  img_orig,
  img_orig_foci,
  artificial_amp_factor,
  coincident_foci
)
}
\arguments{
\item{img_file}{cell's file name}

\item{offset_px, }{Pixel value offset used in thresholding of synaptonemal complex channel}

\item{stage, }{meiosis stage of interest. Currently count_foci determines
this with thresholding/ object properties in the synaptonemal complex channel
by previosly calling the get_pachytene function.
Note that if using this option, the count_foci function requires that the
input directory contains a folder called “pachytene” with the crops in it.}

\item{strands}{black white mask of strand channel}

\item{watershed_stop}{Stop default watershed method with "on"}

\item{foci_label}{black and white mask of foci channel}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{cell_count}{unique cell counter}

\item{img_orig}{original strand crop}

\item{img_orig_foci}{cropped foci channel}

\item{artificial_amp_factor}{amplification factor}

\item{coincident_foci}{mask of coincident foci}
}
\value{
number of foci per cell
}
\description{
creates mask for coincident foci
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auto_crop_fast.R
\name{get_blobs}
\alias{get_blobs}
\title{get_blobs}
\usage{
get_blobs(
  img_orig,
  blob_factor,
  bg_blob_factor,
  offset,
  final_blob_amp,
  brush_size_blob,
  sigma_blob,
  watershed_tol,
  watershed_radius,
  crowded_cells,
  annotation
)
}
\arguments{
\item{img_orig}{Original image}

\item{blob_factor, }{Contrast factor to multiply original image by before
smoothing/smudging}

\item{bg_blob_factor, }{Contrast factor to multiply original image by to take
background. Used prior to thresholding.}

\item{offset, }{Pixel value offset from bg_blob_factor. Used in thresholding
to make blob mask.}

\item{final_blob_amp, }{Contrast factor to multiply smoothed/smudged image.
Used in thresholding to make blob mask.}

\item{brush_size_blob, }{Brush size for smudging the synaptonemal complex channel to make blobs}

\item{sigma_blob, }{Sigma in Gaussian brush for smudging the synaptonemal complex channel to
make blobs}

\item{watershed_tol}{Intensity tolerance for watershed method. Defaults to 0.05.}

\item{watershed_radius}{Radius (ext variable) in watershed method used
in strand channel. Defaults to 1 (small)}

\item{crowded_cells}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have many cells in a frame that almost touch}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)
have many cells in a frame that almost touch}
}
\value{
Mask with cell candidates
}
\description{
Makes mask of all objects bright enough to be classified as a cell
cadidate
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{make_foci_mask}
\alias{make_foci_mask}
\title{make_foci_mask}
\usage{
make_foci_mask(
  offset_factor,
  bg,
  crowded_foci,
  img_orig_foci,
  brush_size,
  brush_sigma,
  disc_size_foci
)
}
\arguments{
\item{offset_factor}{Pixel value offset used in thresholding of foci channel}

\item{bg}{background value- currently just mean pixel value of whole image}

\item{crowded_foci}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have foci > 100 or so.}

\item{img_orig_foci}{cropped foci channel}

\item{brush_size}{size of brush to smooth the foci channel. Should be small
to avoid erasing foci.}

\item{brush_sigma}{sigma for Gaussian smooth of foci channel. Should be
small to avoid erasing foci.}

\item{disc_size_foci}{size of disc for local background calculation in foci channel}
}
\value{
foci mask
}
\description{
creates foci mask for foci channel crop
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{annotate_foci_counting_adjusted}
\alias{annotate_foci_counting_adjusted}
\title{annotate_foci_counting_adjusted}
\usage{
annotate_foci_counting_adjusted(
  img_file,
  cell_count,
  img_orig,
  img_orig_foci,
  artificial_amp_factor,
  strands,
  coincident_foci,
  foci_label,
  alone_foci,
  percent_px,
  foci_per_cell
)
}
\arguments{
\item{img_file}{cell's file name}

\item{cell_count}{unique cell counter}

\item{img_orig}{original strand crop}

\item{img_orig_foci}{cropped foci channel}

\item{artificial_amp_factor}{amplification factor}

\item{strands}{black white mask of strand channel}

\item{coincident_foci}{mask of overlap between strand and foci channel}

\item{foci_label}{black and white mask of foci channel}

\item{alone_foci}{estimated number of foci that are NOT on a strand.}

\item{percent_px}{percentage of foci mask that coincides with strand channel
small number indicates potentially problematic image.}

\item{foci_per_cell}{number of foci counted per cell}
}
\value{
displays key steps from raw image to coincident foci count
}
\description{
Contains all plotting routines for count foci annotation
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{get_C1}
\alias{get_C1}
\title{get_C1}
\usage{
get_C1(foci_areas, foci_per_cell, C_weigh_foci_number)
}
\arguments{
\item{foci_areas}{pixel area of each foci}

\item{foci_per_cell}{foci count for cell}

\item{C_weigh_foci_number}{choose crispness criteria- defaults to TRUE to use
C1 (weighing with number). Otherwise set to FALSE to use C2}
}
\value{
statistic to comapre to crisp_criteria
}
\description{
calculates the statistic to compare to crisp_criteria, which determines
whether the foci count will be reliable
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{append_data_frame}
\alias{append_data_frame}
\title{append_data_frame}
\usage{
append_data_frame(
  WT_str,
  KO_str,
  WT_out,
  KO_out,
  img_file,
  foci_areas,
  df_cells,
  cell_count,
  stage,
  foci_per_cell,
  image_mat,
  percent_px,
  alone_foci,
  discrepant_category,
  C1
)
}
\arguments{
\item{WT_str}{string in filename corresponding to wildtype genotype.
Defaults to ++.}

\item{KO_str}{string in filename corresponding to knockout genotype.
Defaults to --.}

\item{WT_out}{string in output csv in genotype column, for knockout.
Defaults to +/+.}

\item{KO_out}{string in output csv in genotype column, for knockout.
Defaults to -/-.}

\item{img_file}{cell's file name}

\item{foci_areas}{pixel area of each foci}

\item{df_cells}{current data frame}

\item{cell_count}{unique cell counter}

\item{stage, }{meiosis stage of interest. Currently count_foci determines
this with thresholding/ object properties in the synaptonemal complex channel
by previosly calling the get_pachytene function.
Note that if using this option, the count_foci function requires that the
input directory contains a folder called “pachytene” with the crops in it.}

\item{foci_per_cell}{foci count for cell}

\item{image_mat}{matrix with all pixel values above zero}

\item{percent_px}{percentage of foci mask that coincides with strand channel
small number indicates potentially problematic image.}

\item{alone_foci}{estimated number of foci that are NOT on a strand.}

\item{discrepant_category}{estimated number of foci that are NOT on a strand.}

\item{C1}{criteria}
}
\value{
data frame with new row
}
\description{
applies new row to data frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auto_crop_fast.R
\name{keep_cells}
\alias{keep_cells}
\title{keep_cells}
\usage{
keep_cells(
  candidate,
  max_cell_area,
  min_cell_area,
  cell_aspect_ratio,
  crowded_cells,
  annotation
)
}
\arguments{
\item{candidate}{Mask of individual cell candidates}

\item{max_cell_area, }{Maximum pixel area of a cell candidate}

\item{min_cell_area, }{Minimum pixel area of a cell candidate}

\item{cell_aspect_ratio}{Maximum aspect ratio of blob to be defined as a cell}

\item{crowded_cells}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)
have many cells in a frame that almost touch}
}
\value{
Mask of cell candidates which meet size criteria
}
\description{
Deletes objects in mask which are too small, large, oblong
i.e. unlikely to be a cell
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/count_foci.R
\name{remove_XY}
\alias{remove_XY}
\title{remove_XY}
\usage{
remove_XY(foci_label, foci_candidates, foci_areas)
}
\arguments{
\item{foci_label}{black and white mask of foci channel}

\item{foci_candidates}{computeFeatures data frame of foci channel}

\item{foci_areas}{the areas of the foci objects}
}
\value{
mask with XY blob removed
}
\description{
applies new row to data frame
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auto_crop_fast.R
\name{auto_crop_fast}
\alias{auto_crop_fast}
\title{auto_crop_fast}
\usage{
auto_crop_fast(
  img_path,
  max_cell_area = 20000,
  min_cell_area = 7000,
  mean_pix = 0.08,
  annotation = "off",
  blob_factor = 15,
  bg_blob_factor = 10,
  offset = 0.2,
  final_blob_amp = 10,
  test_amount = 0,
  brush_size_blob = 51,
  sigma_blob = 15,
  channel3_string = "DAPI",
  channel2_string = "SYCP3",
  channel1_string = "MLH3",
  file_ext = "jpeg",
  third_channel = "off",
  cell_aspect_ratio = 2,
  strand_amp = 2,
  path_out = img_path,
  resize_l = 720,
  crowded_cells = "FALSE",
  watershed_radius = 50,
  watershed_tol = 0.2,
  cropping_factor = 1.3
)
}
\arguments{
\item{img_path, }{path containing image data to analyse}

\item{max_cell_area, }{Maximum pixel area of a cell candidate}

\item{min_cell_area, }{Minimum pixel area of a cell candidate}

\item{mean_pix, }{Mean pixel intensity of cell crop (in SYCP3 channel)
for normalisation}

\item{annotation, }{Choice to output pipeline choices (recommended to knit)}

\item{blob_factor, }{Contrast factor to multiply original image by before
smoothing/smudging}

\item{bg_blob_factor, }{Contrast factor to multiply original image by to
take background. Used prior to thresholding.}

\item{offset, }{Pixel value offset from bg_blob_factor. Used in thresholding
to make blob mask.}

\item{final_blob_amp, }{Contrast factor to multiply smoothed/smudged image.
Used in thresholding to make blob mask.}

\item{test_amount, }{Optional number of first N images you want to run
function on. For troubleshooting/testing/variable calibration purposes.}

\item{brush_size_blob, }{Brush size for smudging the synaptonemal complex channel to make blobs}

\item{sigma_blob, }{Sigma in Gaussian brush for smudging the synaptonemal complex channel
to make blobs}

\item{channel3_string}{Optional. String appended to the files showing the
channel illuminating cell structures. Defaults to DAPI, if
third channel == "on".}

\item{channel2_string}{String appended to the files showing the channel
illuminating synaptonemal complexes. Defaults to SYCP3}

\item{channel1_string}{String appended to the files showing the channel
illuminating foci. Defaults to MLH3}

\item{file_ext}{file extension of your images e.g. tif jpeg or png.}

\item{third_channel}{Optional, defaults to "off". Set to "on" if you would
also like crops of the third channel.}

\item{cell_aspect_ratio}{Maximum aspect ratio of blob to be defined as a cell}

\item{strand_amp}{multiplication of strand channel for get_blobs function.}

\item{path_out, }{user specified output path. Defaults to img_path}

\item{resize_l}{length for resized image}

\item{crowded_cells}{TRUE or FALSE, defaults to FALSE. Set to TRUE if you
have many cells in a frame that almost touch}

\item{watershed_radius}{Radius (ext variable) in watershed method used
in strand channel. Defaults to 1 (small)}

\item{watershed_tol}{Intensity tolerance for watershed method. Defaults to
0.05.}

\item{cropping_factor}{size of cropping window square, as factor of
characteristic blob radius. Defaults to 1. May need to increase if using
watershed.}
}
\value{
cropped synaptonemal complex and foci channels around single cells, regardless of stage
}
\description{
crop an image around each viable cell candidate.
}
\details{
This function takes all images in a directory, and crops around individual
cells according to the antibody that stains synaptonemal complexes e.g.
SYCP3. First, it increases the brightness and smudges the image with a Gaussian
brush, and creates a mask using thresholding (get_blobs).
Then it deletes cell candidates in the mask deemed too large, too small,
or too long (keep_cells). Using the computeFeatures functions from
EBImage to locate centre and radius, the cropping area is determined and
the original image cropped. These images are saved in either a user specified
directory, or a crops folder at the location of the image files.
}
\examples{
demo_path = paste0(system.file("extdata",package = "synapsis"))
auto_crop_fast(demo_path, annotation = "on", max_cell_area = 30000,
min_cell_area = 7000, file_ext = "tif",crowded_cells = TRUE)
}
\author{
Lucy McNeill
}
